import type * as functions from 'firebase-functions';
import { DatabaseType, type PrivateKeys } from './types';
import { type FirebaseDescriptor } from './FirebaseDescriptor';
export type FirebaseFunctions = FirebaseDescriptor | {
    [key: string]: FirebaseFunctions;
};
export type RunnableFirebaseFunctions = (functions.HttpsFunction & functions.Runnable<unknown>) | functions.CloudFunction<unknown> | functions.HttpsFunction | {
    [key: string]: RunnableFirebaseFunctions;
};
export declare function createFirebaseFunctions(getPrivateKeys: (databaseType: DatabaseType) => PrivateKeys, firebaseFunctions: Record<string, FirebaseFunctions>, debugFirebaseFunctions?: Record<string, FirebaseFunctions>): RunnableFirebaseFunctions;
