import * as functions from 'firebase-functions';
import { type ILogger } from './logger';
import { type IFunctionType, DatabaseType, type PrivateKeys } from './types';
import { type IParameterContainer } from './parameter';
import { type IDatabaseReference, type IDatabaseScheme } from './database';
export interface IFirebaseRequest<FunctionType extends IFunctionType.Erased> {
    parameters: IFunctionType.Parameters<FunctionType>;
    execute(): Promise<IFunctionType.ReturnType<FunctionType>>;
}
export declare namespace FirebaseRequest {
    type Constructor<FunctionType extends IFunctionType.Erased> = new (parameterContainer: IParameterContainer, databaseReference: IDatabaseReference<IDatabaseScheme>, logger: ILogger) => IFirebaseRequest<FunctionType>;
    function create<FunctionType extends IFunctionType.Erased>(FirebaseRequest: FirebaseRequest.Constructor<FunctionType>, getPrivateKeys: (databaseType: DatabaseType) => PrivateKeys): functions.HttpsFunction;
}
