import { type Functions } from 'firebase/functions';
import { Crypter } from '../crypter';
import { type FirebaseFunctions as FirebaseFunctionsType } from '../FirebaseFunctions';
import { type ValidReturnType } from '../types/ValidReturnType';
import { type ExpectResult } from './Expect';
import { type IFunctionType } from '../types';
import { type FirebaseDescriptor } from '../FirebaseDescriptor';
export declare class FirebaseFunctions<FFunctions extends FirebaseFunctionsType> {
    private readonly functions;
    private readonly requestUrlComponent;
    private readonly cryptionKeys;
    private readonly callSecretKey;
    private readonly functionName?;
    constructor(functions: Functions, requestUrlComponent: string, cryptionKeys: Crypter.Keys, callSecretKey: string, functionName?: string | undefined);
    function<Key extends FirebaseFunctions.KeyIfRecord<FFunctions>>(key: Key): FirebaseFunctions<FirebaseFunctions.FFunctionIfRecord<FFunctions, Key>>;
    call(parameters: FirebaseFunctions.ParametersIfFunction<FFunctions>): Promise<ExpectResult<FirebaseFunctions.ReturnTypeIfFunction<FFunctions>>>;
    request(parameters: FirebaseFunctions.ParametersIfRequest<FFunctions>): Promise<ExpectResult<FirebaseFunctions.ReturnTypeIfRequest<FFunctions>>>;
}
declare namespace FirebaseFunctions {
    type KeyIfRecord<FFunctions extends FirebaseFunctionsType> = (FFunctions extends Record<string, FirebaseFunctionsType> ? (keyof FFunctions & string) : never);
    type FFunctionIfRecord<FFunctions extends FirebaseFunctionsType, Key extends keyof FFunctions> = FFunctions extends Record<string, FirebaseFunctionsType> ? FFunctions[Key] : never;
    type ParametersIfFunction<FFunctions extends FirebaseFunctionsType> = FFunctions extends FirebaseDescriptor.Function<IFunctionType<unknown, ValidReturnType, infer FlattenParameters>, unknown> ? FlattenParameters : never;
    type ReturnTypeIfFunction<FFunctions extends FirebaseFunctionsType> = FFunctions extends FirebaseDescriptor.Function<IFunctionType<unknown, infer ReturnType, unknown>, unknown> ? ReturnType : never;
    type ParametersIfRequest<FFunctions extends FirebaseFunctionsType> = FFunctions extends FirebaseDescriptor.Request<IFunctionType<unknown, ValidReturnType, infer FlattenParameters>> ? FlattenParameters : never;
    type ReturnTypeIfRequest<FFunctions extends FirebaseFunctionsType> = FFunctions extends FirebaseDescriptor.Request<IFunctionType<unknown, infer ReturnType, unknown>> ? ReturnType : never;
}
export {};
