import { type FunctionsErrorCode } from 'firebase-functions/lib/common/providers/https';
import { type Result } from './Result';
export interface FirebaseError extends Error {
    name: 'FirebaseError';
    code: FirebaseError.Code;
    message: string;
    details?: unknown;
    stack?: string;
}
export declare namespace FirebaseError {
    type Code = FunctionsErrorCode;
    function isFirebaseErrorCode(code: string): code is FirebaseError.Code;
    function toFirebaseError(error: unknown): FirebaseError;
}
export type FirebaseResult<T> = Result<T, FirebaseError>;
