"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const src_1 = require("../../src");
describe('FirebaseResult', () => {
    it('isFirebaseErrorCode', () => {
        (0, chai_1.expect)(src_1.FirebaseError.isFirebaseErrorCode('invalid')).to.be.false;
        (0, chai_1.expect)(src_1.FirebaseError.isFirebaseErrorCode('ok')).to.be.true;
        (0, chai_1.expect)(src_1.FirebaseError.isFirebaseErrorCode('unauthenticated')).to.be.true;
    });
    it('toFirebaseError', () => {
        (0, chai_1.expect)(src_1.FirebaseError.toFirebaseError(null)).to.be.deep.equal({ name: 'FirebaseError', code: 'unknown', message: 'Unknown error occured, see details for more infos.', details: null, stack: undefined });
        (0, chai_1.expect)(src_1.FirebaseError.toFirebaseError({ code: 'invalid', message: 'the-message', details: 'abc', stack: 'xyz' })).to.be.deep.equal({ name: 'FirebaseError', code: 'unknown', message: 'the-message', details: 'abc', stack: 'xyz' });
        (0, chai_1.expect)(src_1.FirebaseError.toFirebaseError({ code: 'unavailable', message: 'the-message', details: 'abc', stack: 'xyz' })).to.be.deep.equal({ name: 'FirebaseError', code: 'unavailable', message: 'the-message', details: 'abc', stack: 'xyz' });
    });
});
